using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.PostProcessing;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using System.Linq;
using System.Threading;

namespace Feel.medicalpack
{
    public class Pill
    {
        private MVRScript _root;
        private Transform _obj;

        private JSONStorableColor _pill_color;

        public Pill(MVRScript root)
        {
            _root = root;

            HSVColor pill_color = new HSVColor();
            pill_color.H = 0f;
            pill_color.S = 0.58f;
            pill_color.V = 0.76f;
            _pill_color = new JSONStorableColor("pill color", pill_color, OnPillColorChange);
            _root.RegisterColor(_pill_color);

        }

        public void SetObj(Transform obj)
        {
            _obj = obj;

            ShowSyringeUI();
        }

        private void ShowSyringeUI()
        {
            _root.CreateColorPicker(_pill_color);
        }

        private void OnPillColorChange(JSONStorableColor color)
        {
            if (_obj)
            {
                Renderer renderer = _obj.GetComponent<Renderer>();
                foreach (Material material in renderer.materials)
                {
                    Color c = Color.HSVToRGB(color.val.H, color.val.S, color.val.V);
                    material.SetColor("_Color", c);
                }
            }
            
        }

        public void SetUpdate()
        {
            
        }

    }

}